/**
 * JASMINe Deploy ME [Managed Element]
 * Copyright (C) 2012 Bull S.A.S.
 * Copyright (C) 2012 France Telecom R&D
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id: IDeploymeModule.java 10000 2012-05-02 14:52:40Z cazauxj $
 * --------------------------------------------------------------------------
 */
package org.ow2.jasmine.deployme.api.modules;

import org.ow2.jonas.tools.configurator.api.JonasConfigurator;

import java.lang.reflect.Field;
import java.util.Map;

/**
 * Represents a DeployME module
 * @author Jeremy Cazaux
 */
public interface IDeploymeModule {

    /**
     * @return true if the given ConfigurationType is support
     */
    boolean isSupport(Object configuration);

    /**
     * @return a map between the {@link Class} of an {@link Object} and its id field
     *                        (use to improve the merge of Collection)
     */
    Map<Class, Field> getClassIdField();

    /**
     * Apply a configuration
     * @param configurator The {@link JonasConfigurator} to set
     * @param topologyObject The topology object configuration to apply
     */
    void applyConfiguration(JonasConfigurator configurator, Object topologyObject) throws UnsupportDeploymeModuleException;

    /**
     * @return the name of the JOnAS service
     */
    String getJOnASService();
}
